//Oana Citoteanu
//Alexandra Dracea
//333CC

# define F_CPU 1000000UL

#include <stdio.h>
#include <avr\io.h>
#include <util/delay.h>



#define SENSORST 	( 1 << PA5 )	
#define SENSORC		( 1 << PA6 )	
#define SENSORDR 	( 1 << PA7 )	


int main() {

	//setam portul de intrare si iesire
	DDRB=0xFF;
	DDRA=0x00;
	unsigned char senzori;
	int dreapta = 0, stanga = 0;
	int frana_dr = 0, frana_st = 0;
	
	senzori = PINA;

	PORTB = 0x00;
	// Alb = 1 , Negru = 0
	while (1) {
		_delay_ms(2);
		
		senzori = PINA;
		
		
		
	
		//dc sunt cu senzor stang pe alb
		if (!(senzori&SENSORST )){
	
		
			//dc sunt cu senzorul drept pe alb
			if (!(senzori&SENSORDR )){
				frana_dr++;
				if( frana_dr == 2){
					frana_dr = 0;
					PORTB &= ~(1<<PB4);
					PORTB &= ~(1<<PB1);
				}
				else{
					PORTB |= _BV(PB4);
					PORTB &= ~(1<<PB1);
				}
			}
			//dc sunt cu senzorul drept pe negru
			else{
				stanga++;
				if( stanga == 3 ){
					stanga = 0;
					PORTB |= _BV(PB4);
					PORTB &= ~(1<<PB1);
				}
				else{
					PORTB &= ~(1<<PB4);
					PORTB &= ~(1<<PB1);
				}
			}
			
			
			PORTB &= ~(1<<PB5);
		}
		else{
			PORTB &= ~(1<<PB4);
			PORTB &= ~(1<<PB5);
			PORTB |= _BV(PB1);
		}
			
			
			
		//dc sunt cu senzorul drept pe alb
		if (!(senzori&SENSORDR )){
		
			
			//dc sunt cu senzorul stang pe alb
			if (!(senzori&SENSORST )){
				frana_st++;
				if( frana_st == 2 ){
					frana_st = 0;
					PORTB &= ~(1<<PB2);
					PORTB &= ~(1<<PB0);
				}
				else{
					PORTB |= _BV(PB2);
					PORTB &= ~(1<<PB0);
				}
			}
			//dc sunt cu senzorul stang pe negru
			else{
				dreapta++;
				if( dreapta == 3 ){
					dreapta = 0;
					PORTB |= _BV(PB2);
					PORTB &= ~(1<<PB0);
				}
				else{
					PORTB &= ~(1<<PB2);
					PORTB &= ~(1<<PB0);
				}
			}
				
			
			
			PORTB &= ~(1<<PB3);
		}
		//dc sunt cu senzorul drept pe negru
		else{
			PORTB &= ~(1<<PB2);
			PORTB &= ~(1<<PB3);
			PORTB |= _BV(PB0);
		}
		
		
		
		
		//dc sunt cu senzorii ( drept sau stang ) pe alb, aprind led-urile verzi
		if(   (!(senzori&SENSORDR ))  ||  (!(senzori&SENSORST ))  ){
			PORTB |= _BV(PB6);
			PORTB |= _BV(PB7);
		}
		//altfel sunt stinse
		else{
			PORTB &= ~(1<<PB6);
			PORTB &= ~(1<<PB7);
		}
		
	}
	
	return 0;
}
